/// <reference path="libs/jquery.d.ts" />
/// <reference path="tools/XmlString.ts" />
/// <reference path="jxfamille/GameController.ts" />
//window.ready
/**
 * Recupere la veleur d'un parametre defini dans l'url.
 */
function getParam(param) {
    //On separe la chaine des parametres en fonction du &.
    var spath = window.location.search.split("&"), i;

    for (i = 0; i < spath.length; ++i) {
        var hash = spath[i].split("=");
        var hash_param = hash[0].replace("?", "");
        var hash_val = hash[1];

        //On recupere le parametre de l'url si il existe.
        if (hash_param == param) {
            return hash_val;
        }
    }
}

function onReady() {
    $("#loading").hide().remove();

    _gameController.start();
}
;
var _gameController;
var xmlString;
$(document).ready(function () {
    _gameController = new jxfamille.GameController(document.getElementById("famille"));
    jxfamille.GameController.xmlString = new tools.XmlString(onReady);

    /********************************************************************************/ //Prechargement des images.
    /********************************************************************************/ //On precharge l'image du loader.
    $("<img />").attr({src: "img/loader.gif", alt: "chargement"}).load(function () {
        $(this).remove();
        //$("#loading").html($(this));
    });

    $('img').on('dragstart', function (event) {
        event.preventDefault();
    });
});

window.onload = function () {
    var lg = getParam("lang") ? getParam("lang") : "fr";
    jxfamille.GameController.xmlString.loadLang(lg);
    var testTocken = tools.TokenUtil.replaceTokens("test ${test1}", {test1: "textToken"});
    console.log("testTocken ", testTocken);
    /*
     $("#loading").hide().remove();


     _gameController.start();
     */
    /*
     $('#c_sterilite').compteur({
     target   : 45
     });
     $('#c_mariage').compteur({
     target   : 12
     });
     */
};

console = { log: function () {
        } };
if (typeof console == "undefined" || typeof console.log == "undefined")
    console = {log: function () {
        }};
/// <reference path="/libs/dgreensock.d.ts" />
/// <reference path="tools/MouseTools.ts" />
/// <reference path="jxfamille/Accueil.ts" />
/// <reference path="jxfamille/ChoixSex.ts" />
/// <reference path="jxfamille/Activite.ts" />
var jxfamille;
(function (jxfamille) {
    var GameController = (function () {
        function GameController(element) {
            this.element = element;

            this._accueil = new jxfamille.Accueil(document.getElementById('p1'));
            this._choixSex = new jxfamille.ChoixSex(document.getElementById('p2'));
            this._activite = new jxfamille.Activite(document.getElementById('p3'));

            this.addlisteners();
        }
        GameController.prototype.addlisteners = function () {
            var _this = this;
            var btn_p1_p2 = document.getElementById('p1-p2-btn');

            tools.MouseTools.addClickListener(btn_p1_p2, function (event) {
                return _this.on_click_p1_p2(event);
            });

            tools.MouseTools.addClickListener(document.getElementById('p2-p3-btn-h'), function (event) {
                return _this.on_click_p2_p3_h(event);
            });

            tools.MouseTools.addClickListener(document.getElementById('p2-p3-btn-f'), function (event) {
                return _this.on_click_p2_p3_f(event);
            });

            tools.MouseTools.addClickListener(document.getElementById('p3-intro-btn'), function (event) {
                return _this.on_click_p3_intro(event);
            });
            tools.MouseTools.addClickListener(document.getElementById('p3-sterilite-btn'), function (event) {
                return _this.on_click_p3_sterilite(event);
            });
            tools.MouseTools.addClickListener(document.getElementById('p3-couple-btn'), function (event) {
                return _this.on_click_p3_couple(event);
            });
            tools.MouseTools.addClickListener(document.getElementById('p3-allait-btn'), function (event) {
                return _this.on_click_p3_allait(event);
            });
            tools.MouseTools.addClickListener(document.getElementById('p3-enfants-btn'), function (event) {
                return _this.on_click_p3_enfants(event);
            });
            tools.MouseTools.addClickListener(document.getElementById('p3-contraception-btn'), function (event) {
                return _this.on_click_p3_contraception(event);
            });
            tools.MouseTools.addClickListener(document.getElementById('p3-conclusion-btn'), function (event) {
                return _this.on_click_p3_conclusion(event);
            });
        };

        GameController.prototype.start = function () {
            GameController.xmlString.initGenericText();

            this._accueil.start();
            this._choixSex.stop();
            this._activite.stop();
        };

        GameController.prototype.on_click_p1_p2 = function (e) {
            // console.log("Greeter on_Click",e, this);
            this._accueil.stop();
            this._choixSex.start();
        };

        GameController.prototype.on_click_p2_p3_h = function (e) {
            this.currentSex_h = true;
            $(".f").remove();
            this._choixSex.stop();
            this._activite.start();
        };

        GameController.prototype.on_click_p2_p3_f = function (e) {
            $(".h").remove();
            this.currentSex_h = false;
            this._choixSex.stop();
            this._activite.start();
        };

        GameController.prototype.on_click_p3_intro = function (e) {
            this._choixSex.stop();
            this._activite.start();
        };

        GameController.prototype.on_click_p3_sterilite = function (e) {
            //  this._activite.start();
            this._activite.select(3);
        };
        GameController.prototype.on_click_p3_couple = function (e) {
            // this._activite.start();
            this._activite.select(6);
        };
        GameController.prototype.on_click_p3_allait = function (e) {
            // this._activite.start();
            this._activite.select(9);
        };
        GameController.prototype.on_click_p3_enfants = function (e) {
            //this._activite.start();
            this._activite.select(11);
        };
        GameController.prototype.on_click_p3_contraception = function (e) {
            //this._activite.start();
            this._activite.select(13);
        };
        GameController.prototype.on_click_p3_conclusion = function (e) {
            //this._activite.start();
            this._activite.select(16);
        };

        GameController.prototype.progress_activite = function (index) {
            this._activite.progress_to(index);
        };
        return GameController;
    })();
    jxfamille.GameController = GameController;
})(jxfamille || (jxfamille = {}));
var tools;
(function (tools) {
    var MouseTools = (function () {
        function MouseTools() {
        }
        MouseTools.addClickListener = function (elt, callback) {
            if (elt.addEventListener) {
                elt.addEventListener("click", function (event) {
                    return callback(event);
                }, false);
            } else if (elt.attachEvent) {
                elt.attachEvent("onclick", function (event) {
                    return callback(event);
                });
            }
        };
        MouseTools.addClickListenerList = function (elt, callback) {
            for (var i = 0; i < elt.length; i++) {
                this.addClickListener(elt[i], callback);
            }
        };

        MouseTools.toArray = function (e) {
            return [].slice.call(e);
        };

        MouseTools.addSelectListener = function (elt, callback) {
            if (elt.addEventListener) {
                elt.addEventListener("change", function (event) {
                    return callback(event);
                }, false);
                //      elt.addEventListener("click", event => callback(event), false);
            } else if (elt.attachEvent) {
                elt.attachEvent("onchange", function (event) {
                    return callback(event);
                });
                //     elt.attachEvent("onclick", event => callback(event));
            }
        };
        return MouseTools;
    })();
    tools.MouseTools = MouseTools;
})(tools || (tools = {}));
/// <reference path="libs/jquery.d.ts" />
/// <reference path="/libs/dgreensock.d.ts" />
/// <reference path="jxfamille/Intro.ts" />
/// <reference path="jxfamille/Evolution.ts" />
/// <reference path="jxfamille/Progress.ts" />
var jxfamille;
(function (jxfamille) {
    var Activite = (function () {
        function Activite(element) {
            this.maxEtape = 17;
            this._current = 0;
            this.element = element;
            this._progess = new jxfamille.Progress(document.getElementById('p3-progress'));
            this._intro = new jxfamille.Intro(document.getElementById('p3-intro'));
            this._Evolution = new jxfamille.Evolution(document.getElementById('p3-evolution'));

            // TweenMax.to(this.element, 0, {autoAlpha:0});
            $(this.element).hide();

            this.addlisteners();
        }
        Activite.prototype.addlisteners = function () {
            var _this = this;
            $('.suite').on("click", function (event) {
                return _this.on_click_suite(event);
            });
            $('.retour').on("click", function (event) {
                return _this.on_click_retour(event);
            });
            //tools.MouseTools.addClickListener(document.getElementsByClassName('suite'), event => this.on_click_suite(event));
        };

        Activite.prototype.on_click_suite = function (e) {
            this.select(this._current + 1);
        };

        Activite.prototype.on_click_retour = function (e) {
            if (this._current == 0) {
                this._intro.start();
                this._Evolution.stop();
            } else {
                this.select(this._current - 1);
            }
        };

        Activite.prototype.start = function () {
            $(this.element).show();

            //          TweenMax.to(this.element, 0, {autoAlpha:0});
            TweenMax.to(document.getElementsByClassName('retour'), 0, {autoAlpha: 0});
            this._current = 0;
            this._progess.start();
            this._intro.start();
            this._Evolution.stop();
            // $('.retour').hide();
        };

        Activite.prototype.stop = function () {
            // $(this.element).hide();
            this._progess.stop();
            this._intro.stop();
            this._Evolution.stop();

            // console.log("Activite hide", this);
            //TweenMax.to(this.element, 0.5, { autoAlpha: 0 });
            $(this.element).hide();
        };

        Activite.prototype.progress_to = function (index) {
            if (index > this._current) {
                this.select(index);
            }
        };

        Activite.prototype.select = function (id) {
            var prev_current = this._current;
            this._current = id;
            console.log("Activite select ->", this._current);
            this._intro.stop();
            if (prev_current < 1 && this._current >= 1) {
                this._Evolution.start();
            }

            switch (this._current) {
                case 0:
                    this._progess.select(0);
                    this._Evolution.stop();
                    this._intro.start();
                    break;
                case 1:
                    this._Evolution.etape_0();
                    break;
                case 2:
                    this._Evolution.etape_1();
                    break;
                case 3:
                    this._progess.select(1);
                    this._Evolution.etape_2();
                    break;
                case 4:
                    this._Evolution.etape_3();
                    break;
                case 5:
                    this._Evolution.etape_4();
                    break;
                case 6:
                    this._progess.select(2);
                    this._Evolution.etape_5();
                    break;
                case 7:
                    this._Evolution.etape_6();
                    break;
                case 8:
                    this._Evolution.etape_7();
                    break;

                case 9:
                    this._progess.select(3);
                    this._Evolution.etape_8();
                    break;
                case 10:
                    this._Evolution.etape_9();
                    break;
                case 11:
                    this._progess.select(4);
                    this._Evolution.etape_10();
                    break;
                case 12:
                    this._Evolution.etape_11();
                    break;
                case 13:
                    this._progess.select(5);
                    this._Evolution.etape_12();
                    break;
                case 14:
                    this._Evolution.etape_13();
                    break;
                case 15:
                    this._Evolution.etape_14();
                    break;
                case 16:
                    this._progess.select(6);
                    this._Evolution.etape_15();
                    break;
                default:
            }
            if (this._current == 0) {
                TweenMax.to(document.getElementsByClassName('retour'), 0, {autoAlpha: 0});
            } else {
                TweenMax.to(document.getElementsByClassName('retour'), 0, {autoAlpha: 1});
            }
        };
        return Activite;
    })();
    jxfamille.Activite = Activite;
})(jxfamille || (jxfamille = {}));
/// <reference path="/libs/dgreensock.d.ts" />
/// <reference path="libs/jquery.d.ts" />
var jxfamille;
(function (jxfamille) {
    var Evolution = (function () {
        function Evolution(element) {
            var _this = this;
            this.etapeMax = 16;
            this.min_chrono_x = 21;
            this.max_chrono_x = 75;
            this.listeClear = false;
            this.base_bebe_marginRight = -37;
            this.perdu_alpha = 0.1;
            this.potentiel_alpha = 0.2;
            this.desire_alpha = 1;
            this.ne_alpha = 1;
            this.ok_alpha = 1;
            /*
             sterilisation : 1
             pilule : 3
             sterilet : 3
             preservatif : 10
             abstinence : 30
             retrait : 30
             grisgris : 100

             */
            this.arr_contraception = [1, 3, 3, 10, 30, 30, 100];
            this.prevRisques = 0;
            this.element = element;

            //      TweenMax.to(this.element, 0, {css:{alpha:0}});
            this.n_puberte = 12;
            this.max_allaitement = 24;
            this.n_sterilite = 0;
            this.max_sterilite = 50;
            this.n_mariage = this.n_puberte;
            this.n_allaitement = 3;
            this.max_desire = 25;
            this.n_desire = 2;
            this.n_contraception = 0;

            this.step_chrono = (this.max_chrono_x - this.min_chrono_x) / (this.max_sterilite - this.n_puberte);

            this.addlisteners();
            this.n_sterilite = this.max_sterilite;

            document.getElementById('b_contraception').selectedIndex = 0;

            this._hideAllStartId();
            this.updateShowid(0);

            this.onResize();
            $(window);
            $(window).on("resize", function (event) {
                return _this.onResize();
            });
        }
        Evolution.prototype.start = function () {
            this.updateCompteurs();

            //this._hideAllStartId();
            $(this.element).fadeIn();

            //   TweenMax.to(this.element, 0, {autoAlpha:0});
            // TweenMax.to(this.element, 0.5, { autoAlpha: 1 });
            this.currentEtape = 0;
            this._hideAllStartId();
            this.updateShowid(0);
            this.onResize();
            //   $(this.element).find(".animation").fadeIn();
        };

        Evolution.prototype.stop = function () {
            // $(this.element).find(".animation").fadeOut();
            $(this.element).fadeOut();
            this._hideAllStartId();
            //     console.log("Evolution hide", this);
            // TweenMax.to(this.element, 0.5, {autoAlpha:0});
        };

        Evolution.prototype.addlisteners = function () {
            var _this = this;
            tools.MouseTools.addClickListener(document.getElementById('b_sterilite'), function (event) {
                return _this.on_click_b_sterilite(event);
            });
            tools.MouseTools.addClickListener(document.getElementById('b_mariagep'), function (event) {
                return _this.on_click_b_mariagep(event);
            });
            tools.MouseTools.addClickListener(document.getElementById('b_mariagem'), function (event) {
                return _this.on_click_b_mariagem(event);
            });
            tools.MouseTools.addClickListener(document.getElementById('b_allaitementp'), function (event) {
                return _this.on_click_b_allaitementp(event);
            });
            tools.MouseTools.addClickListener(document.getElementById('b_allaitementm'), function (event) {
                return _this.on_click_b_allaitementm(event);
            });
            tools.MouseTools.addClickListener(document.getElementById('b_desirep'), function (event) {
                return _this.on_click_b_desirep(event);
            });
            tools.MouseTools.addClickListener(document.getElementById('b_desirem'), function (event) {
                return _this.on_click_b_desirem(event);
            });
            tools.MouseTools.addSelectListener(document.getElementById('b_contraception'), function (event) {
                return _this.on_click_b_contraception(event);
            });
        };

        Evolution.prototype.on_click_b_sterilite = function (e) {
            this.n_sterilite = Math.floor(Math.random() * 20 + 30);
            this.updateCompteurs();
            _gameController.progress_activite(5);
        };
        Evolution.prototype.on_click_b_mariagep = function (e) {
            if (this.n_mariage < this.n_sterilite) {
                this.n_mariage += 1;
            }
            this.updateCompteurs();

            _gameController.progress_activite(8);
        };
        Evolution.prototype.on_click_b_mariagem = function (e) {
            if (this.n_mariage > this.n_puberte) {
                this.n_mariage -= 1;
            }
            this.updateCompteurs();

            _gameController.progress_activite(8);
        };

        Evolution.prototype.updateTxtMariage = function () {
            var chaine;
            if (_gameController.currentSex_h) {
                if (this.n_mariage >= this.n_sterilite) {
                    chaine = jxfamille.GameController.xmlString.dico['famille_ans_lors_du_mariage_h0'];
                } else if (this.n_potentiel > 1) {
                    chaine = jxfamille.GameController.xmlString.dico['famille_ans_lors_du_mariage_h'];
                } else {
                    chaine = jxfamille.GameController.xmlString.dico['famille_ans_lors_du_mariage_h1'];
                }
            } else {
                if (this.n_mariage >= this.n_sterilite) {
                    chaine = jxfamille.GameController.xmlString.dico['famille_ans_lors_du_mariage_f0'];
                } else if (this.n_potentiel > 1) {
                    chaine = jxfamille.GameController.xmlString.dico['famille_ans_lors_du_mariage_f'];
                } else {
                    chaine = jxfamille.GameController.xmlString.dico['famille_ans_lors_du_mariage_f1'];
                }
            }

            // Votre femme ayant ${age} ans lors de votre mariage ou du dÃ©but de votre vie de couple, le nombre dâ€™enfants que vous pouvez avoir est rÃ©duit de ${reduit}, ce qui la ramÃ¨ne Ã  ${potentiel} enfants
            var texte = tools.TokenUtil.replaceTokens(chaine, {age: this.n_mariage.toString(), reduit: this.getBabiesBeforeMariage().toString(), potentiel: this.n_potentiel.toString()});
            jxfamille.GameController.xmlString.processElements("data-txt", "famille_ans_lors_du_mariage", texte);
        };

        Evolution.prototype.on_click_b_allaitementp = function (e) {
            if (this.n_allaitement < this.max_allaitement) {
                this.n_allaitement += 1;
            }
            this.updateCompteurs();
        };
        Evolution.prototype.on_click_b_allaitementm = function (e) {
            if (this.n_allaitement > 0) {
                this.n_allaitement -= 1;
            }
            this.updateCompteurs();
        };
        Evolution.prototype.on_click_b_desirep = function (e) {
            //  if (this.n_desire < this.max_desire) {
            this.n_desire += 1;

            //  }
            this.updateCompteurs();
        };
        Evolution.prototype.on_click_b_desirem = function (e) {
            if (this.n_desire > 0) {
                this.n_desire -= 1;
            }
            this.updateCompteurs();
        };

        Evolution.prototype.on_click_b_contraception = function (e) {
            if (!this.listeClear) {
                this.listeClear = true;
                this.parentDefault = $('#b_contraception_default').parent().first();
                this.removedDefault = $('#b_contraception_default').remove();
            }

            //document.getElementById('b_contraception_default').de
            var index = document.getElementById('b_contraception').selectedIndex;
            console.log("on_click_b_contraception ", index);
            this.updateCompteurs();

            TweenMax.to(document.getElementsByClassName('ss_txt_compteur'), 0.5, {autoAlpha: 1});
            _gameController.progress_activite(15);
        };

        // restaure les parametres pas defaut
        Evolution.prototype.incrementalRestore = function () {
            if (this.currentEtape <= 13) {
                this.n_contraception = 0;
                if (this.listeClear) {
                    this.listeClear = false;
                    this.parentDefault.prepend(this.removedDefault);
                    document.getElementById('b_contraception').selectedIndex = 0;
                }
            }
            if (this.currentEtape <= 11) {
                this.n_desire = 2;
            }

            //this.max_desire = 25;
            /*
             this.n_puberte = 12;
             this.max_allaitement = 24;
             this.n_sterilite = 0;
             this.max_sterilite = 50;
             this.n_mariage = this.n_puberte;
             this.n_allaitement = 3;
             */
            if (this.currentEtape <= 9) {
                this.n_allaitement = 3;
            }
            if (this.currentEtape <= 6) {
                this.n_mariage = this.n_puberte;
            }
            if (this.currentEtape <= 3) {
                this.n_sterilite = this.max_sterilite;
            }
            if (this.currentEtape > 1) {
                this.updateCompteurs();
            }
        };

        Evolution.prototype.updateShowid = function (id) {
            var prevEtape = this.currentEtape;
            this.currentEtape = id;
            console.log("updateShowid ", id, this);
            if (prevEtape > this.currentEtape) {
                this.incrementalRestore();
            }

            for (var i = 0; i < this.etapeMax; i++) {
                if (i != id) {
                    this._hideId(i);
                }
                if (id < i) {
                    this._hideStartId(i);
                }
            }
            for (var i = 0; i < this.etapeMax; i++) {
                if (i == id) {
                    this._showId(i);
                }
                if (id >= i) {
                    this._showStartId(i);
                }
            }
            this.updateBebeList();
        };

        Evolution.prototype.onResize = function () {
            TweenMax.to(document.getElementById('liste_bebe'), 0.5, {left: this.min_chrono_x + "%"});

            var deltaPos = ($('#box_menopause').offset().left - 10) - $('#box_regles').offset().left;
            var arr_bab = tools.MouseTools.toArray(document.getElementById("liste_bebe").getElementsByTagName("img"));
            var bebEspace = -37 + deltaPos / arr_bab.length;
            TweenMax.staggerTo(arr_bab, 0, {css: {marginRight: bebEspace}}, 0.01);
            // $(".c_desire.infobulle").css("left",$("#c_desire").offset().left+"px");
        };

        Evolution.prototype.updateBebeList = function () {
            var x_mariage = Math.floor(this.min_chrono_x + this.step_chrono * (this.n_mariage - this.n_puberte));

            var arr_bab = tools.MouseTools.toArray(document.getElementById("liste_bebe").getElementsByTagName("img"));

            /*
             TweenMax.to(document.getElementById('liste_bebe'), 0.5, { left: this.min_chrono_x + "%" });

             var deltaPos = $('#box_menopause').offset().left - $('#box_regles').offset().left;

             var bebEspace = -37 + deltaPos / arr_bab.length;
             TweenMax.staggerTo(arr_bab, 0,  {css:{marginRight:bebEspace}}, 0.01);
             */
            if (this.currentEtape == 0) {
                TweenMax.staggerTo(arr_bab, 0, {autoAlpha: 0}, 0.01);
                return;
            }

            // getBabiesBeforeMariage()
            if (this.currentEtape > 1) {
                // var arr_bab = tools.MouseTools.toArray(document.getElementById("liste_bebe").getElementsByTagName("img"));
                var nb_max = this.getBabiesPotentielMax();
                var step = nb_max / this.n_potentiel;
                var arr_potentiel = [];

                /*
                 for (var i=0;i < this.n_potentiel; i++) {
                 // avec trou                    var index = this.getBabiesBeforeMariage() + Math.round(i*step)-i;
                 var index = this.getBabiesBeforeMariage() +i;
                 arr_potentiel.push(arr_bab.splice(index,1));
                 }*/
                arr_potentiel = arr_bab.splice(this.getBabiesBeforeMariage(), this.n_potentiel);

                //var arr_potentiel = arr_bab.splice(this.getBabiesBeforeMariage(), this.n_potentiel);
                //var arr_bab_off = arr_bab.splice(0, this.getBabiesBeforeMariage()).concat()
                if (this.currentEtape < 11) {
                    TweenMax.staggerTo(arr_bab.reverse(), 0, {autoAlpha: this.perdu_alpha}, 0.01);
                    TweenMax.staggerTo(arr_potentiel, 0, {autoAlpha: this.ne_alpha}, 0.01);
                } else {
                    var arr_ne = arr_potentiel.slice(0, this.n_ne);
                    var arr_desire = arr_ne.slice(0, this.n_desire);

                    TweenMax.staggerTo(arr_bab.reverse(), 0, {autoAlpha: this.perdu_alpha}, 0.01);
                    TweenMax.staggerTo(arr_potentiel, 0, {autoAlpha: this.potentiel_alpha}, 0.01);
                    TweenMax.staggerTo(arr_ne, 0, {autoAlpha: this.ne_alpha}, 0.01);
                    TweenMax.staggerTo(arr_desire, 0, {autoAlpha: this.desire_alpha}, 0.01);
                }
            }
        };

        Evolution.prototype.etape_0 = function () {
            this.updateShowid(0);

            //TweenMax.to(document.getElementById("liste_bebe"), 0, { autoAlpha: 0 });
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, {autoAlpha: 1});
        };

        Evolution.prototype.etape_1 = function () {
            this.updateShowid(1);

            //TweenMax.to(document.getElementById("liste_bebe"), 0, { autoAlpha: 1 });
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, {autoAlpha: 1});
        };
        Evolution.prototype.etape_2 = function () {
            this.updateShowid(2);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, {autoAlpha: 1});
        };

        Evolution.prototype.etape_3 = function () {
            this.updateShowid(3);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, {autoAlpha: 1});
            //TweenMax.to(document.getElementsByClassName('suite'), 0, { autoAlpha: 0 });
        };
        Evolution.prototype.etape_4 = function () {
            this.updateShowid(4);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, {autoAlpha: 1});
        };

        Evolution.prototype.etape_5 = function () {
            this.updateShowid(5);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, {autoAlpha: 1});
        };
        Evolution.prototype.etape_6 = function () {
            this.updateShowid(6);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, {autoAlpha: 1});
            //TweenMax.to(document.getElementsByClassName('suite'), 0, { autoAlpha: 0 });
        };
        Evolution.prototype.etape_7 = function () {
            this.updateShowid(7);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, {autoAlpha: 1});
        };
        Evolution.prototype.etape_8 = function () {
            this.updateShowid(8);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, {autoAlpha: 1});
        };
        Evolution.prototype.etape_9 = function () {
            this.updateShowid(9);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, {autoAlpha: 1});
            //TweenMax.to(document.getElementsByClassName('suite'), 0, { autoAlpha: 0 });
        };
        Evolution.prototype.etape_10 = function () {
            this.updateShowid(10);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, {autoAlpha: 1});
        };
        Evolution.prototype.etape_11 = function () {
            this.updateShowid(11);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, {autoAlpha: 1});
            //TweenMax.to(document.getElementsByClassName('suite'), 0, { autoAlpha: 0 });
        };
        Evolution.prototype.etape_12 = function () {
            this.updateShowid(12);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, {autoAlpha: 1});
        };
        Evolution.prototype.etape_13 = function () {
            this.updateShowid(13);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, {autoAlpha: 1});
            //TweenMax.to(document.getElementsByClassName('suite'), 0, { autoAlpha: 0 });
        };
        Evolution.prototype.etape_14 = function () {
            this.updateShowid(14);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, {autoAlpha: 1});
        };
        Evolution.prototype.etape_15 = function () {
            this.updateShowid(15);
            TweenMax.to(document.getElementsByClassName('suite'), 0, {autoAlpha: 0});
        };

        Evolution.prototype._showId = function (id) {
            $('.info_' + id + ".toggle").stop().show();

            $('.info_' + id).not(".toggle").stop().fadeIn();
            //TweenMax.staggerTo(tools.MouseTools.toArray(this.element.getElementsByClassName('info_' + id)), 0, { autoAlpha: 1 }, 0);
        };
        Evolution.prototype._hideId = function (id) {
            $('.info_' + id + ".toggle").not('.info_' + this.currentEtape).stop().hide();
            $('.info_' + id).not(".toggle").not('.info_' + this.currentEtape).stop().fadeOut();
            //TweenMax.staggerTo(tools.MouseTools.toArray(this.element.getElementsByClassName('info_' + id)), 0, { autoAlpha: 0 }, 0);
        };

        Evolution.prototype._showStartId = function (id) {
            $('.info_start_' + id).stop().show();
            //TweenMax.staggerTo(tools.MouseTools.toArray(this.element.getElementsByClassName('info_start_' + id)), 0, { autoAlpha: 1 }, 0);
        };
        Evolution.prototype._hideStartId = function (id) {
            $('.info_start_' + id).stop().hide();
            //TweenMax.staggerTo(tools.MouseTools.toArray(this.element.getElementsByClassName('info_start_' + id)), 0, { autoAlpha: 0 }, 0);
        };
        Evolution.prototype._hideAllStartId = function () {
            for (var i = 0; i < this.etapeMax; i++) {
                //    $('.info_start_' + i).hide();
                $('.info_start_' + i).stop().show();
                //TweenMax.staggerTo(tools.MouseTools.toArray(this.element.getElementsByClassName('info_start_' + i)), 0, { autoAlpha: 0 }, 0);
            }
        };

        Evolution.prototype.updateCompteurs = function () {
            var _this = this;
            if ((this.currentEtape + 1) < this.etapeMax) {
                TweenMax.to(document.getElementsByClassName('suite'), 0.5, {autoAlpha: 1});
            }
            $('#c_sterilite').compteur({target: this.n_sterilite});

            // min_chrono_x:number
            var x_sterilite = Math.floor(this.min_chrono_x + this.step_chrono * (this.n_sterilite - this.n_puberte));
            TweenMax.to(document.getElementById('box_sterilite'), 0.5, {left: x_sterilite + "%"});

            $('#c_mariage').compteur({target: this.n_mariage});
            $('#c_allaitement').compteur({target: this.n_allaitement});
            this.updateBabesPotentiel();

            //this.n_desire = Math.min(this.n_desire, this.n_potentiel);
            $('#c_desire').compteur({target: this.n_desire});

            this.updateBabesDesire();
            this.n_contraception = this.getBabiesByContraception();
            $('#c_contraception').compteur({target: this.n_contraception});
            $('.nb_enfantsSup').html(this.n_contraception.toString());
            this.updateBabesne();
            $('.n_sterilite').each(function (i, item) {
                item.innerHTML = _this.n_sterilite.toString();
            });

            //  document.getElementsByClassName('n_sterilite').innerText = this.n_sterilite.toString();
            //   document.getElementById('max_sterilite').innerText=this.max_sterilite.toString()
            // document.getElementById('n_mariage').innerText = this.n_mariage.toString();
            $('.n_mariage').each(function (i, item) {
                item.innerHTML = _this.n_mariage.toString();
            });
            $('.n_desire').each(function (i, item) {
                item.innerHTML = _this.n_desire.toString();
            });
            $('.n_reduit').each(function (i, item) {
                item.innerHTML = (_this.max_desire - _this.n_potentiel).toString();
            });

            //  document.getElementById('n_puberte').innerText=this.n_puberte.toString();
            var x_mariage = Math.floor(this.min_chrono_x + this.step_chrono * (this.n_mariage - this.n_puberte));
            TweenMax.to(document.getElementById('box_mariage'), 0.5, {left: x_mariage + "%"});

            this.updateBebeList();

            //$(".c_desire.infobulle").css("left",$("#c_desire").offset().left+"px");
            if (this.n_desire > this.n_potentiel && $("#c_desire").css("display") != "none") {
                $(".c_desire.infobulle").queue("fx", []).stop();
                $(".c_desire.infobulle").fadeIn().delay(2000).fadeOut();
            }

            this.updateTxtContraception();
            this.updateTxtCapacite();
            this.updateTxtEnPlus();
            this.updateTxtMariage();
        };

        Evolution.prototype.getContraceptionRisque = function () {
            var index = Math.max(document.getElementById('b_contraception').selectedIndex, 0);

            return this.arr_contraception[index];
        };

        Evolution.prototype.getBabiesByContraception = function () {
            var babMorePossibles = this.getBabiesPotentiel() - this.n_desire;
            var pcRisque = this.getContraceptionRisque() * babMorePossibles / 100;

            var ret = Math.round(Math.random() * pcRisque);
            if (this.prevRisques != pcRisque) {
                this.prevRisques = pcRisque;
                return (ret);
            } else {
                return this.n_contraception;
            }
        };

        Evolution.prototype.getAllaitementMonths = function () {
            return Math.max(18, (18 + this.n_allaitement * 2 / 3 - 2));
        };

        Evolution.prototype.getBabiesPotentiel = function () {
            var _loc1 = Math.round((this.n_sterilite - this.n_mariage) * 12 / this.getAllaitementMonths());
            return (_loc1 >= 0 ? (_loc1) : (0));
        };

        Evolution.prototype.getBabiesBeforeMariage = function () {
            // return this.max_desire-this.getBabiesPotentielMax()
            return Math.min(Math.round((this.n_mariage - this.n_puberte) * 12 / 18), this.max_desire - this.getBabiesPotentiel());
        };

        Evolution.prototype.getBabiesPotentielMax = function () {
            return Math.round((this.n_sterilite - this.n_mariage) * 12 / 18);
        };

        Evolution.prototype.updateBabesDesire = function () {
            var pot = this.n_desire;
            console.log("updateBabesDesire ", pot);

            $('.n_desire').each(function (i, item) {
                item.innerHTML == pot.toString();
                ;
            });
        };

        Evolution.prototype.updateBabesPotentiel = function () {
            var _this = this;
            var pot = this.getBabiesPotentiel();
            console.log("updateBabesPotentiel ", pot);
            this.n_potentiel = pot;

            // document.getElementById('n_potentiel').innerText = pot.toString();
            $('.n_potentiel').each(function (i, item) {
                item.innerHTML = pot.toString();
                ;
            });

            $('.n_supp').each(function (i, item) {
                item.innerHTML = (pot - _this.n_desire).toString();
                ;
            });
        };

        // famille_votre_capacite ->
        // famille_votre_capacite_sterile + famille_votre_capacite_f(1) famille_votre_capacite_h(1) + famille_votre_capacite_potentiel_f(1) famille_votre_capacite_potentiel_h(1)
        //  n_sterilite  n_reduit n_potentiel
        Evolution.prototype.updateTxtCapacite = function () {
            var n_reduit = (this.max_desire - this.n_potentiel);
            var chaine;
            chaine = jxfamille.GameController.xmlString.dico['famille_votre_capacite_sterile'];
            if (_gameController.currentSex_h) {
                if (n_reduit > 1) {
                    chaine += jxfamille.GameController.xmlString.dico['famille_votre_capacite_h'];
                } else {
                    chaine += jxfamille.GameController.xmlString.dico['famille_votre_capacite_h1'];
                }
                if (this.n_potentiel > 1) {
                    chaine += jxfamille.GameController.xmlString.dico['famille_votre_capacite_potentiel_h'];
                } else {
                    chaine += jxfamille.GameController.xmlString.dico['famille_votre_capacite_potentiel_h1'];
                }
            } else {
                if (n_reduit > 1) {
                    chaine += jxfamille.GameController.xmlString.dico['famille_votre_capacite_f'];
                } else {
                    chaine += jxfamille.GameController.xmlString.dico['famille_votre_capacite_f1'];
                }
                if (this.n_potentiel > 1) {
                    chaine += jxfamille.GameController.xmlString.dico['famille_votre_capacite_potentiel_f'];
                } else {
                    chaine += jxfamille.GameController.xmlString.dico['famille_votre_capacite_potentiel_f1'];
                }
            }

            // Votre femme ayant ${age} ans lors de votre mariage ou du dÃ©but de votre vie de couple, le nombre dâ€™enfants que vous pouvez avoir est rÃ©duit de ${reduit}, ce qui la ramÃ¨ne Ã  ${potentiel} enfants
            var texte = tools.TokenUtil.replaceTokens(chaine, {n_sterilite: this.n_sterilite.toString(), n_reduit: n_reduit.toString(), n_potentiel: this.n_potentiel.toString()});
            jxfamille.GameController.xmlString.processElements("data-txt", "famille_votre_capacite", texte);
        };

        // famille_sans_contraception famille_contraception_pas_limitation   n_desire n_supp
        Evolution.prototype.updateTxtContraception = function () {
            var n_supp = this.n_potentiel - this.n_desire;
            var chaine;
            if (n_supp > 0) {
                chaine = jxfamille.GameController.xmlString.dico['famille_sans_contraception'];
            } else {
                if (this.n_desire > 1) {
                    chaine = jxfamille.GameController.xmlString.dico['famille_contraception_pas_limitation'];
                } else {
                    chaine = jxfamille.GameController.xmlString.dico['famille_sans_contraception1'];
                }
            }

            var texte = tools.TokenUtil.replaceTokens(chaine, {n_desire: this.n_desire.toString(), n_supp: n_supp.toString()});
            jxfamille.GameController.xmlString.processElements("data-txt", "famille_sans_contraception", texte);
        };

        /*
         <item _title="famille_pas_bebe_en_plus"><![CDATA[Pas de bÃ©bÃ© de plus que dÃ©sirÃ©.]]></item>
         <item _title="famille_titre_bebes_en_plus"><![CDATA[${nb_enfantsSup} bÃ©bÃ©s de plus que dÃ©sirÃ©]]></item>
         <item _title="famille_titre_bebe_en_plus"><![CDATA[${nb_enfantsSup} bÃ©bÃ© de plus que dÃ©sirÃ©]]></item>
         */
        Evolution.prototype.updateTxtEnPlus = function () {
            var chaine;
            if (this.n_contraception > 1) {
                chaine = jxfamille.GameController.xmlString.dico['famille_titre_bebes_en_plus'];
            } else if (this.n_contraception > 0) {
                chaine = jxfamille.GameController.xmlString.dico['famille_titre_bebe_en_plus'];
            } else {
                chaine = jxfamille.GameController.xmlString.dico['famille_pas_bebe_en_plus'];
            }

            var texte = tools.TokenUtil.replaceTokens(chaine, {nb_enfantsSup: this.n_contraception.toString()});
            jxfamille.GameController.xmlString.processElements("data-txt", "famille_titre_bebes_en_plus", texte);
        };

        Evolution.prototype.updateBabesne = function () {
            var pot = this.n_contraception + Math.min(this.n_desire, this.n_potentiel);
            console.log("updateBabesne ", pot);
            this.n_ne = pot;

            // document.getElementById('n_ne').innerText = pot.toString();
            $('.n_ne').each(function (i, item) {
                item.innerHTML = pot.toString();
                ;
            });
        };
        return Evolution;
    })();
    jxfamille.Evolution = Evolution;
})(jxfamille || (jxfamille = {}));
var tools;
(function (tools) {
    var TokenUtil = (function () {
        function TokenUtil() {
        }
        TokenUtil.CURLY_BRACES_PATTERN = function () {
            return /\$\{([\w'-]+)\}/g;
        };
        TokenUtil.BRACKET_PATTERN = function () {
            return /\$\[([\w'-]+)\]/g;
        };

        /**
         * This util will take a string, search for ${tokens} and replace them
         * with the values in the supplied object.
         * @param text - text you would like to search for tokens
         * @param paramObj - an object to use to find and replace tokens with
         * @param replaceUndefineds - string to use when undefined are found
         * @param overrideRegEx - override the default regex pattern
         * @return
         *
         */
        TokenUtil.replaceTokens = function (text, paramObj, replaceUndefineds, overrideRegEx) {
            if (typeof paramObj === "undefined") {
                paramObj = null;
            }
            if (typeof replaceUndefineds === "undefined") {
                replaceUndefineds = "";
            }
            if (typeof overrideRegEx === "undefined") {
                overrideRegEx = null;
            }
            if (!paramObj) {
                return text;
            } else {
                var myRegEx = overrideRegEx ? overrideRegEx : this.CURLY_BRACES_PATTERN();
                var cleanText = text.replace(myRegEx, function (substring) {
                    var args = [];
                    for (var _i = 0; _i < (arguments.length - 1); _i++) {
                        args[_i] = arguments[_i + 1];
                    }
                    return paramObj[args[0]];
                });

                //  function():*{return paramObj[arguments[1]]});
                //replaceUndefineds
                cleanText = cleanText.replace(/undefined/gi, function (substring) {
                    var args = [];
                    for (var _i = 0; _i < (arguments.length - 1); _i++) {
                        args[_i] = arguments[_i + 1];
                    }
                    return replaceUndefineds;
                });
                return cleanText;
            }
        };
        return TokenUtil;
    })();
    tools.TokenUtil = TokenUtil;
})(tools || (tools = {}));
/// <reference path="/libs/dgreensock.d.ts" />
var jxfamille;
(function (jxfamille) {
    var Progress = (function () {
        function Progress(element) {
            this.element = element;
            $(this.element).hide();
            // TweenMax.to(this.element, 0, {autoAlpha:0});
        }
        Progress.prototype.start = function () {
            $(this.element).show();

            //      TweenMax.to(this.element, 0, {autoAlpha:0});
            //     TweenMax.to(this.element, 0.5, {autoAlpha:1});
            this.list = this.element.getElementsByTagName("a");

            this.select(0);
        };

        Progress.prototype.stop = function () {
            $(this.element).hide();
            console.log("Intro hide", this);
            //   TweenMax.to(this.element, 0.5, {autoAlpha:0});
        };

        Progress.prototype.select = function (id) {
            $(this.list).removeClass("selected");
            $(this.list.item(id)).addClass("selected");
        };
        return Progress;
    })();
    jxfamille.Progress = Progress;
})(jxfamille || (jxfamille = {}));
/// <reference path="libs/jquery.d.ts" />
var tools;
(function (tools) {
    var XmlString = (function () {
        function XmlString(callBack) {
            this.callBack = callBack;
            this.dico = {};
        }
        XmlString.prototype.loadLang = function (filename) {
            $.ajax({
                context: this,
                type: "GET",
                url: filename + ".xml",
                dataType: "xml",
                error: this.onLangError,
                success: this.onLangLoaded
            });
        };

        XmlString.prototype.onLangLoaded = function (xml) {
            console.log("onLangLoaded ", xml);
            var list = xml.getElementsByTagName("item");
            for (var i = 0; i < list.length; i++) {
                var item = list.item(i);
                var oAt = item.attributes.getNamedItem("_title");
                if (oAt != null) {
                    oAt.value;
                    item.textContent;
                    this.dico[oAt.value] = item.textContent;
                }
            }
            this.callBack();
        };

        XmlString.prototype.initGenericText = function () {
            for (var v in this.dico) {
                this.processElements("data-txt", v, this.dico[v]);
            }
        };

        XmlString.prototype.processElements = function (attribute, template, data) {
            var _this = this;
            var toFind = "[" + attribute + "='" + template + "']";
            console.log("processElements ", toFind, "->", attribute, template, data);
            $("[" + attribute + "='" + template + "']").each(function (i, item) {
                console.log("each ", i, item, data);
                _this.applyTemplateon(i, item, data);
            });
        };

        XmlString.prototype.applyTemplateon = function (i, item, data) {
            console.log("applyTemplateon ", i, item, data);
            item.innerHTML = data;
            /*
             function () {
             var $this = $(this),
             param = $this.attr(attribute),
             value = getValue(data, param);

             if (!valueIsAllowedByBindingOptions($this, value, settings)) {
             $this.remove();
             return;
             }

             $this.removeAttr(attribute);

             if (typeof value !== 'undefined' && dataBindFunction) {
             dataBindFunction($this, value);
             } else if (noDataFunction) {
             noDataFunction($this);
             }
             });
             return;
             */
        };

        XmlString.prototype.onLangError = function () {
            console.log("onLangError ");
        };
        return XmlString;
    })();
    tools.XmlString = XmlString;
})(tools || (tools = {}));
/// <reference path="/libs/dgreensock.d.ts" />
var jxfamille;
(function (jxfamille) {
    var Intro = (function () {
        function Intro(element) {
            this.element = element;
            //      TweenMax.to(this.element, 0, {css:{alpha:0}});
        }
        Intro.prototype.start = function () {
            $(this.element).show();

            //           TweenMax.to(this.element, 0, {autoAlpha:0});
            //          TweenMax.to(this.element, 0.5, {autoAlpha:1});
            //  TweenMax.staggerTo(tools.MouseTools.toArray(this.element.getElementsByClassName('info')), 0, { autoAlpha: 1 },0);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, {autoAlpha: 1});
            $('.info_intro').fadeIn();
            $(this.element).find(".animation").fadeIn();
        };

        Intro.prototype.stop = function () {
            $(this.element).hide();
            $('.info_intro').fadeOut();
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, {autoAlpha: 0});
            console.log("Intro hide", this);
            $(this.element).find(".animation").fadeOut();
            //  TweenMax.to(this.element, 0.5, {autoAlpha:0});
        };
        return Intro;
    })();
    jxfamille.Intro = Intro;
})(jxfamille || (jxfamille = {}));
/// <reference path="/libs/dgreensock.d.ts" />
var jxfamille;
(function (jxfamille) {
    var ChoixSex = (function () {
        function ChoixSex(element) {
            this.element = element;

            //TweenMax.to(this.element, 0, {autoAlpha:0});
            $(this.element).hide();
            $('#p2_titre').hide();
            $('#p2-p3-btn-h').hide();
            $('#p2-p3-btn-f').hide();
            //  $('.btns_sex').slideUp()
        }
        ChoixSex.prototype.start = function () {
            $(this.element).show();
            $('#p2_titre').fadeIn();
            $('#p2-p3-btn-h').fadeIn();
            $('#p2-p3-btn-f').fadeIn();
            //  $('.btns_sex').slideDown("slow")
            //      TweenMax.to(this.element, 0, {autoAlpha:0});
            //      TweenMax.to(this.element, 0.5, {autoAlpha:1});
        };

        ChoixSex.prototype.stop = function () {
            $(this.element).hide();
            $('#p2_titre').hide();
            $('#p2-p3-btn-h').hide();
            $('#p2-p3-btn-f').hide();

            //    $('.btns_sex').slideUp()
            console.log("ChoixSex hide", this);
            //     TweenMax.to(this.element, 0.5, {autoAlpha:0});
        };
        return ChoixSex;
    })();
    jxfamille.ChoixSex = ChoixSex;
})(jxfamille || (jxfamille = {}));
/// <reference path="/libs/dgreensock.d.ts" />
var jxfamille;
(function (jxfamille) {
    var Accueil = (function () {
        function Accueil(element) {
            this.element = element;

            // TweenMax.to(this.element, 0, {autoAlpha:0});
            $(this.element).hide();
            $('#p1-bebe').hide();
            $('#p1-3age').hide();
            $('#p1-ado').hide();
        }
        Accueil.prototype.start = function () {
            $(this.element).fadeIn();
            $('#p1-bebe').fadeIn();
            $('#p1-3age').fadeIn();
            $('#p1-ado').fadeIn();
            //    TweenMax.to(this.element, 0, {autoAlpha:0});
            //    TweenMax.to(this.element, 0.5, {autoAlpha:1});
        };

        Accueil.prototype.stop = function () {
            $(this.element).fadeOut().hide();
            $('#p1-bebe').hide();
            $('#p1-3age').hide();
            $('#p1-ado').hide();
            console.log("Accueil hide", this);
            //   TweenMax.to(this.element, 0.5, {autoAlpha:0});
        };
        return Accueil;
    })();
    jxfamille.Accueil = Accueil;
})(jxfamille || (jxfamille = {}));
//# sourceMappingURL=app.js.map